function PlayerManager:damage_reduction_skill_multiplier_hehe()
	--thanks overkill :)))
	--custom function to fetch damage reductions due to fucking crew chief stupid ass implementation
	local multiplier = 1
	multiplier = multiplier * self:upgrade_value("player", "damage_dampener", 1)
	multiplier = multiplier * self:upgrade_value("player", "health_damage_reduction", 1)
	multiplier = multiplier * self._properties:get_property("revive_damage_reduction", 1)
	multiplier = multiplier * self._temporary_properties:get_property("revived_damage_reduction", 1)

	local dmg_red_mul = self:team_upgrade_value("damage_dampener", "team_damage_reduction", 1)

	multiplier = multiplier * dmg_red_mul

	return multiplier
end

function PlayerManager:cal_conditional_damage_reduction()
	local multiplier = 1
	local upgrades = {
		underdog_value = managers.player:check_upgrade_value("temporary", "dmg_dampener_outnumbered", 1, 1),
		close_contact_value = managers.player:check_upgrade_value("temporary", "dmg_dampener_close_contact", 1, 1),
		out_num_infi = managers.player:check_upgrade_value("temporary", "dmg_dampener_outnumbered_strong", 1, 1)
	}

	for i, upg in pairs(upgrades) do
		multiplier = multiplier * upg
	end

	if managers.player:has_category_upgrade("player", "passive_damage_reduction") then
		multiplier = multiplier * (managers.player:team_upgrade_value("damage_dampener", "team_damage_reduction") - (1 - managers.player:team_upgrade_value("damage_dampener", "team_damage_reduction")))
	end

	---CUSTOM------CUSTOM------CUSTOM------CUSTOM------CUSTOM------CUSTOM------CUSTOM------CUSTOM------CUSTOM------CUSTOM---
	--i could make it by using check_upgrade_value() but i rather make sure to check "manually"
	if managers.player:has_category_upgrade("player", "no_armor_damage_reduction") then
		multiplier = multiplier * managers.player:upgrade_value("player", "no_armor_damage_reduction", 1)
	end

	---CUSTOM------CUSTOM------CUSTOM------CUSTOM------CUSTOM------CUSTOM------CUSTOM------CUSTOM------CUSTOM------CUSTOM---

	return multiplier
end

function PlayerManager:check_upgrade_value(category, upgrade, index, default)
	local upgrade_value = self:upgrade_value(category, upgrade)

	if upgrade_value == 0 then
		return default
	end

	return upgrade_value[index] or default or 0
end


function PlayerManager:fetch_henchmans_upgrades(definition_id, upgrade_id, default)
	local data =  tweak_data.upgrades.values.team[upgrade_id][1]
	local upgrades = 0

	for index = 1, 3 do
		local loadout = managers.blackmarket:henchman_loadout(index)
		if loadout.skill == definition_id then
			upgrades = data
		end
	end

	return upgrades or default or 0
end

function PlayerManager:fetch_health_regen_per_seconds_percentages()
	local pl_man_health_regen = self:health_regen()
	local health_regen_seconds_perc = 0

	health_regen_seconds_perc = health_regen_seconds_perc + self:upgrade_value("player", "hostage_health_regen_addend", 0)

	return (health_regen_seconds_perc + pl_man_health_regen) * 100
end

function PlayerManager:fetch_health_flat_regen_per_seconds()
	local health_regen_per_seconds = 0

	health_regen_per_seconds = health_regen_per_seconds + self:fetch_henchmans_upgrades("crew_regen", "crew_health_regen", 0)

	return health_regen_per_seconds * 10
end

function PlayerManager:fetch_health_flat_regen_per_kill()
	local health_regen = 0

	health_regen = health_regen + self:upgrade_value("player", "headshot_regen_health_bonus", 0)
	health_regen = health_regen + self:upgrade_value("player", "armor_health_store_amount", 0)
	health_regen = health_regen + self:upgrade_value("player", "wild_health_amount", 0)
	health_regen = health_regen + self:upgrade_value("player", "pocket_ecm_heal_on_kill", 0)
	health_regen = health_regen + self:check_upgrade_value("player", "tag_team_base", "kill_health_gain", 0)

	return health_regen * 10
end

function PlayerManager:fetch_health_regen_per_kill_percentages()
	local health_regen_percentage = 0

	health_regen_percentage = health_regen_percentage + self:check_upgrade_value("temporary", "melee_life_leech", 1, 0)
	health_regen_percentage = health_regen_percentage + self:upgrade_value("player", "melee_kill_life_leech", 0)

	return health_regen_percentage * 100
end